<?php
#-----------------------------------------------------#
#          ********* ROTORCMS *********               #
#              Made by  :  VANTUZ                     #
#               E-mail  :  visavi.net@mail.ru         #
#                 Site  :  http://pizdec.ru           #
#             WAP-Site  :  http://visavi.net          #
#                  ICQ  :  36-44-66                   #
#  Вы не имеете право вносить изменения в код скрипта #
#        для его дальнейшего распространения          #
#-----------------------------------------------------#	
require_once ('../includes/start.php');
require_once ('../includes/functions.php');
require_once ('../includes/header.php');
include_once ('../themes/' . $config['themes'] . '/index.php');

if (isset($_GET['act'])) {
  $act = check($_GET['act']);
} else {
  $act = 'index';
} 
if (isset($_GET['start'])) {
  $start = abs(intval($_GET['start']));
} else {
  $start = 0;
} 

show_title('site.png', 'Гостевая книга');
$config['newtitle'] = 'Гостевая книга';

switch ($act):
# ###########################################################################################
# #                                    Главная страница                                    ##
# ###########################################################################################
case "index":

  echo '<a href="#down"><img src="../images/img/downs.gif" alt="down" /></a> ';
  echo '<a href="index.php?rand=' . mt_rand(100, 999) . '&amp;' . SID . '">Обновить</a>';
  if (is_admin(array(101, 102, 103, 105))) {
    echo ' / <a href="' . ADMINDIR . 'book.php?start=' . $start . '&amp;' . SID . '">Управление</a>';
  } 
  echo '<hr />';

  $total = DB :: $dbh -> querySingle("SELECT count(*) FROM `guest`;");

  if ($total > 0) {
    if ($start >= $total) {
      $start = 0;
    } 

    $page = floor(1 + $start / $config['bookpost']);
    $config['newtitle'] = 'Гостевая книга (Стр. ' . $page . ')';

    $queryguest = DB :: $dbh -> query("SELECT * FROM `guest` ORDER BY `guest_time` DESC LIMIT " . $start . ", " . $config['bookpost'] . ";");

    while ($data = $queryguest -> fetch()) {
      echo '<div class="b">';
      echo '<div class="img">' . user_avatars($data['guest_user']) . '</div>';

      if ($data['guest_user'] == $config['guestsuser']) {
        echo '<b>' . $data['guest_user'] . '</b> <small>(' . date_fixed($data['guest_time']) . ')</small>';
      } else {
        echo '<b><a href="../pages/anketa.php?uz=' . $data['guest_user'] . '&amp;' . SID . '">' . nickname($data['guest_user']) . '</a></b> <small>(' . date_fixed($data['guest_time']) . ')</small><br />';
        echo user_title($data['guest_user']) . ' ' . user_online($data['guest_user']);
      } 

      echo '</div>';

      if (!empty($log) && $log != $data['guest_user']) {
        echo '<div class="right">';
        echo '<a href="index.php?act=reply&amp;id=' . $data['guest_id'] . '&amp;start=' . $start . '&amp;' . SID . '">Отв</a> / ';
        echo '<a href="index.php?act=quote&amp;id=' . $data['guest_id'] . '&amp;start=' . $start . '&amp;' . SID . '">Цит</a> / ';
        echo '<a href="index.php?act=spam&amp;id=' . $data['guest_id'] . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" onclick="return confirm(\'Вы подтверждаете факт спама?\')">Спам</a></div>';
      } 

      if ($log == $data['guest_user'] && $data['guest_time'] + 600 > SITETIME) {
        echo '<div class="right"><a href="index.php?act=edit&amp;id=' . $data['guest_id'] . '&amp;start=' . $start . '&amp;' . SID . '">Редактировать</a></div>';
      } 

      echo '<div>' . bb_code($data['guest_text']) . '<br />';

      if (!empty($data['guest_edit'])) {
        echo '<img src="../images/img/exclamation_small.gif" alt="image" /> <small>Отредактировано: ' . nickname($data['guest_edit']) . ' (' . date_fixed($data['guest_edit_time']) . ')</small><br />';
      } 

      echo '<span class="data">(' . $data['guest_brow'] . ', ' . $data['guest_ip'] . ')</span>';

      if (!empty($data['guest_reply'])) {
        echo '<br /><span style="color:#ff0000">Ответ: ' . $data['guest_reply'] . '</span>';
      } 

      echo '</div>';
    } 

    page_strnavigation('index.php?', $config['bookpost'], $start, $total);
  } else {
    show_error('Сообщений нет, будь первым!');
  } 

  if (is_user()) {
    echo '<div class="form" id="form">';
    echo '<form action="index.php?act=add&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" name="form" method="post">';
    echo 'Сообщение:<br />';
    echo '<textarea cols="25" rows="3" name="msg"></textarea><br />';

    if (!empty($udata['users_bbpanel'])) {
      quickpaste('msg');
      quickcode();
      quicksmiles();
    } 

    echo '<input type="submit" value="Написать" /></form></div><br />';
  } elseif ($config['bookadds'] == 1) {
    echo '<div class="form" id="form">';
    echo '<form action="index.php?act=add&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" method="post">';
    echo 'Сообщение:<br />';
    echo '<textarea cols="25" rows="3" name="msg"></textarea><br />';

    echo 'Проверочный код:<br /> ';
    echo '<input name="provkod" size="6" maxlength="6" /> ';

    if ($config['protectimg'] == 1) {
      echo '<img src="../gallery/protect.php?' . SID . '" alt="" /><br />';
    } else {
      echo '<b>' . $_SESSION['protect'] . '</b><br />';
    } 

    echo '<br /><input type="submit" value="Написать" /></form></div><br />';
  } else {
    show_login('Вы не авторизованы, чтобы добавить сообщение, необходимо');
  } 

  echo '<a href="#up"><img src="../images/img/ups.gif" alt="image" /></a> ';
  echo '<a href="../pages/pravila.php?' . SID . '">Правила</a> / ';
  echo '<a href="../pages/smiles.php?' . SID . '">Смайлы</a> / ';
  echo '<a href="../pages/tegi.php?' . SID . '">Теги</a><br /><br />';
  break;
# ###########################################################################################
# #                                    Добавление сообщения                                ##
# ###########################################################################################
case "add":

  $msg = check($_POST['msg']);
  $uid = check($_GET['uid']);

  if (is_user()) {
    if ($uid == $_SESSION['token']) {
      if (utf_strlen($msg) >= 5 && utf_strlen($msg) < 1000) {
        if (is_quarantine($log) || $config['bookadds'] == 1) {
          if (is_flood($log)) {
            $msg = no_br($msg);
            $msg = antimat($msg);
            $msg = smiles($msg);

            DB :: $dbh -> query("UPDATE `users` SET `users_allguest`=`users_allguest`+1, `users_point`=`users_point`+1, `users_money`=`users_money`+5 WHERE `users_login`=?", array($log));

            DB :: $dbh -> query("INSERT INTO `guest` (`guest_user`, `guest_text`, `guest_ip`, `guest_brow`, `guest_time`) VALUES (?, ?, ?, ?, ?);", array($log, $msg, $ip, $brow, SITETIME));

            DB :: $dbh -> query("DELETE FROM `guest` WHERE `guest_time` < (SELECT MIN(`guest_time`) FROM (SELECT `guest_time` FROM `guest` ORDER BY `guest_time` DESC LIMIT " . $config['maxpostbook'] . ") AS del);");

            $_SESSION['note'] = 'Сообщение успешно добавлено!';
            header ("Location: index.php?" . SID);
            exit;
          } else {
            show_error('Антифлуд! Разрешается отправлять сообщения раз в ' . flood_period() . ' секунд!');
          } 
        } else {
          show_error('Карантин! Вы не можете писать в течении ' . round($config['karantin'] / 3600) . ' часов!');
        } 
      } else {
        show_error('Ошибка! Слишком длинное или короткое сообщение!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 
    # ###########################################################################################
    # #                                   Добавление для гостей                                ##
    # ###########################################################################################
  } elseif ($config['bookadds'] == 1) {
    $provkod = (int)$_POST['provkod'];

    if ($uid == $_SESSION['token']) {
      if (utf_strlen($msg) >= 5 && utf_strlen($msg) < 1000) {
        if ($provkod == $_SESSION['protect']) {
          if (is_flood($log)) {
            unset($_SESSION['protect']);

            $msg = no_br($msg);
            $msg = antimat($msg);
            $msg = smiles($msg);

            DB :: $dbh -> query("INSERT INTO `guest` (`guest_user`, `guest_text`, `guest_ip`, `guest_brow`, `guest_time`) VALUES (?, ?, ?, ?, ?);", array($config['guestsuser'], $msg, $ip, $brow, SITETIME));

            DB :: $dbh -> query("DELETE FROM `guest` WHERE `guest_time` < (SELECT MIN(`guest_time`) FROM (SELECT `guest_time` FROM `guest` ORDER BY `guest_time` DESC LIMIT " . $config['maxpostbook'] . ") AS del);");

            $_SESSION['note'] = 'Сообщение успешно добавлено!';
            header ("Location: index.php?" . SID);
            exit;
          } else {
            show_error('Антифлуд! Разрешается отправлять сообщения раз в ' . flood_period() . ' секунд!');
          } 
        } else {
          show_error('Ошибка! Проверочное число не совпало с данными на картинке!');
        } 
      } else {
        show_error('Ошибка! Слишком длинное или короткое сообщение!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 
  } else {
    show_login('Вы не авторизованы, чтобы добавить сообщение, необходимо');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="index.php?' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                    Жалоба на спам                                      ##
# ###########################################################################################
case "spam":

  $uid = check($_GET['uid']);
  $id = abs(intval($_GET['id']));

  if (is_user()) {
    if ($uid == $_SESSION['token']) {
      $queryguest = DB :: $dbh -> query("SELECT * FROM `guest` WHERE `guest_id`=? LIMIT 1;", array($id));
      $data = $queryguest -> fetch();

      if (!empty($data)) {
        $queryspam = DB :: $dbh -> querySingle("SELECT `spam_id` FROM `spam` WHERE `spam_key`=? AND `spam_idnum`=? LIMIT 1;", array(2, $id));

        if (empty($queryspam)) {
          if (is_flood($log)) {
            DB :: $dbh -> query("INSERT INTO `spam` (`spam_key`, `spam_idnum`, `spam_user`, `spam_login`, `spam_text`, `spam_time`, `spam_addtime`, `spam_link`) VALUES (?, ?, ?, ?, ?, ?, ?, ?);", array(2, $data['guest_id'], $log, $data['guest_user'], $data['guest_text'], $data['guest_time'], SITETIME, $config['home'] . '/book/index.php?start=' . $start));

            $_SESSION['note'] = 'Жалоба успешно отправлена!';
            header ("Location: index.php?start=$start&" . SID);
            exit;
          } else {
            show_error('Антифлуд! Разрешается жаловаться на спам не чаще чем раз в ' . flood_period() . ' секунд!');
          } 
        } else {
          show_error('Ошибка! Жалоба на данное сообщение уже отправлена!');
        } 
      } else {
        show_error('Ошибка! Выбранное вами сообщение для жалобы не существует!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 
  } else {
    show_login('Вы не авторизованы, чтобы подать жалобу, необходимо');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="index.php?start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                   Ответ на сообщение                                   ##
# ###########################################################################################
case "reply":

  $id = abs(intval($_GET['id']));

  echo '<b><big>Ответ на сообщение</big></b><br /><br />';

  if (is_user()) {
    $queryguest = DB :: $dbh -> query("SELECT * FROM `guest` WHERE `guest_id`=? LIMIT 1;", array($id));
    $post = $queryguest -> fetch();

    if (!empty($post)) {
      echo '<div class="b">';
      echo '<div class="img">' . user_avatars($post['guest_user']) . '</div>';

      if ($post['guest_user'] == $config['guestsuser']) {
        echo '<b>' . $post['guest_user'] . '</b> <small>(' . date_fixed($post['guest_time']) . ')</small>';
      } else {
        echo '<b><a href="../pages/anketa.php?uz=' . $post['guest_user'] . '&amp;' . SID . '">' . nickname($post['guest_user']) . '</a></b> <small>(' . date_fixed($post['guest_time']) . ')</small><br />';
        echo user_title($post['guest_user']) . ' ' . user_online($post['guest_user']);
      } 
      echo '</div>';
      echo '<div>Сообщение: ' . bb_code($post['guest_text']) . '</div><hr />';

      echo '<div class="form" id="form">';
      echo '<form action="index.php?act=add&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" name="form" method="post">';
      echo 'Сообщение:<br />';
      echo '<textarea cols="25" rows="5" name="msg" id="msg">[b]' . nickname($post['guest_user']) . '[/b], </textarea><br />';

      if (!empty($udata['users_bbpanel'])) {
        quickpaste('msg');
        quickcode();
        quicksmiles();
      } 

      echo '<input type="submit" value="Ответить" /></form></div><br />';
    } else {
      show_error('Ошибка! Выбранное вами сообщение для ответа не существует!');
    } 
  } else {
    show_login('Вы не авторизованы, чтобы отвечать на сообщения, необходимо');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="index.php?start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                   Цитирование сообщения                                ##
# ###########################################################################################
case "quote":

  $id = abs(intval($_GET['id']));

  echo '<b><big>Цитирование</big></b><br /><br />';
  if (is_user()) {
    $queryguest = DB :: $dbh -> query("SELECT * FROM `guest` WHERE `guest_id`=? LIMIT 1;", array($id));
    $post = $queryguest -> fetch();

    if (!empty($post)) {
      $post['guest_text'] = nosmiles($post['guest_text']);
      $post['guest_text'] = preg_replace('|\[q\](.*?)\[/q\](<br />)?|', '', $post['guest_text']);
      $post['guest_text'] = str_replace('<br />', "\r\n", $post['guest_text']);

      echo '<div class="form" id="form">';
      echo '<form action="index.php?act=add&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" name="form" method="post">';
      echo 'Сообщение:<br />';
      echo '<textarea cols="25" rows="5" name="msg" id="msg">[q][b]' . nickname($post['guest_user']) . '[/b] (' . date_fixed($post['guest_time']) . ')' . "\r\n" . $post['guest_text'] . '[/q]' . "\r\n" . '</textarea><br />';

      if (!empty($udata['users_bbpanel'])) {
        quickpaste('msg');
        quickcode();
        quicksmiles();
      } 

      echo '<input type="submit" value="Цитировать" /></form></div><br />';
    } else {
      show_error('Ошибка! Выбранное вами сообщение для цитирования не существует!');
    } 
  } else {
    show_login('Вы не авторизованы, чтобы цитировать сообщения, необходимо');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="index.php?start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                   Подготовка к редактированию                          ##
# ###########################################################################################
case "edit":

  $id = abs(intval($_GET['id']));

  if (is_user()) {
    $querypost = DB :: $dbh -> query("SELECT * FROM `guest` WHERE `guest_id`=? AND `guest_user`=? LIMIT 1;", array($id, $log));
    $post = $querypost -> fetch();

    if (!empty($post)) {
      if ($post['guest_time'] + 600 > SITETIME) {
        $post['guest_text'] = nosmiles($post['guest_text']);
        $post['guest_text'] = str_replace('<br />', "\r\n", $post['guest_text']);

        echo '<img src="../images/img/edit.gif" alt="image" /> <b>' . nickname($post['guest_user']) . '</b> <small>(' . date_fixed($post['guest_time']) . ')</small><br /><br />';

        echo '<div class="form" id="form">';
        echo '<form action="index.php?act=editpost&amp;id=' . $id . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" name="form" method="post">';
        echo 'Редактирование сообщения:<br />';
        echo '<textarea cols="25" rows="5" name="msg">' . $post['guest_text'] . '</textarea><br />';

        if (!empty($udata['users_bbpanel'])) {
          quickpaste('msg');
          quickcode();
          quicksmiles();
        } 

        echo '<input value="Редактировать" name="do" type="submit" /></form></div><br />';
      } else {
        show_error('Ошибка! Редактирование невозможно, прошло более 10 минут!!');
      } 
    } else {
      show_error('Ошибка! Сообщение удалено или вы не автор этого сообщения!');
    } 
  } else {
    show_login('Вы не авторизованы, чтобы редактировать сообщения, необходимо');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="index.php?start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                    Редактирование сообщения                            ##
# ###########################################################################################
case "editpost":

  $uid = check($_GET['uid']);
  $id = abs(intval($_GET['id']));
  $msg = check($_POST['msg']);

  if (is_user()) {
    if ($uid == $_SESSION['token']) {
      if (utf_strlen($msg) >= 5 && utf_strlen($msg) < 1000) {
        $querypost = DB :: $dbh -> query("SELECT * FROM `guest` WHERE `guest_id`=? AND `guest_user`=? LIMIT 1;", array($id, $log));
        $post = $querypost -> fetch();

        if (!empty($post)) {
          if ($post['guest_time'] + 600 > SITETIME) {
            $msg = no_br($msg);
            $msg = antimat($msg);
            $msg = smiles($msg);

            DB :: $dbh -> query("UPDATE `guest` SET `guest_text`=?, `guest_edit`=?, `guest_edit_time`=? WHERE `guest_id`=?", array($msg, $log, SITETIME, $id));

            $_SESSION['note'] = 'Сообщение успешно отредактировано!';
            header ("Location: index.php?start=$start&" . SID);
            exit;
          } else {
            show_error('Ошибка! Редактирование невозможно, прошло более 10 минут!!');
          } 
        } else {
          show_error('Ошибка! Сообщение удалено или вы не автор этого сообщения!');
        } 
      } else {
        show_error('Ошибка! Слишком длинное или короткое сообщение!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 
  } else {
    show_login('Вы не авторизованы, чтобы редактировать сообщения, необходимо');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="index.php?act=edit&amp;id=' . $id . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
  echo '<img src="../images/img/reload.gif" alt="image" /> <a href="index.php?start=' . $start . '&amp;' . SID . '">В гостевую</a><br />';
  break;

default:
  header("location: index.php?" . SID);
  endswitch;

  echo '<img src="../images/img/homepage.gif" alt="image" /> <a href="../index.php?' . SID . '">На главную</a>';

  include_once ("../themes/" . $config['themes'] . "/foot.php");

  ?>